// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package auth

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/auth0/auth0_models"
)

// NewPostCredentialsParams creates a new PostCredentialsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostCredentialsParams() *PostCredentialsParams {
	return &PostCredentialsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostCredentialsParamsWithTimeout creates a new PostCredentialsParams object
// with the ability to set a timeout on a request.
func NewPostCredentialsParamsWithTimeout(timeout time.Duration) *PostCredentialsParams {
	return &PostCredentialsParams{
		timeout: timeout,
	}
}

// NewPostCredentialsParamsWithContext creates a new PostCredentialsParams object
// with the ability to set a context for a request.
func NewPostCredentialsParamsWithContext(ctx context.Context) *PostCredentialsParams {
	return &PostCredentialsParams{
		Context: ctx,
	}
}

// NewPostCredentialsParamsWithHTTPClient creates a new PostCredentialsParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostCredentialsParamsWithHTTPClient(client *http.Client) *PostCredentialsParams {
	return &PostCredentialsParams{
		HTTPClient: client,
	}
}

/*
PostCredentialsParams contains all the parameters to send to the API endpoint

	for the post credentials operation.

	Typically these are written to a http.Request.
*/
type PostCredentialsParams struct {

	/* CredentialsRequest.

	   Get Authentation Token
	*/
	CredentialsRequest *auth0_models.CredentialsRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post credentials params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostCredentialsParams) WithDefaults() *PostCredentialsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post credentials params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostCredentialsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post credentials params
func (o *PostCredentialsParams) WithTimeout(timeout time.Duration) *PostCredentialsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post credentials params
func (o *PostCredentialsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post credentials params
func (o *PostCredentialsParams) WithContext(ctx context.Context) *PostCredentialsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post credentials params
func (o *PostCredentialsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post credentials params
func (o *PostCredentialsParams) WithHTTPClient(client *http.Client) *PostCredentialsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post credentials params
func (o *PostCredentialsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithCredentialsRequest adds the credentialsRequest to the post credentials params
func (o *PostCredentialsParams) WithCredentialsRequest(credentialsRequest *auth0_models.CredentialsRequest) *PostCredentialsParams {
	o.SetCredentialsRequest(credentialsRequest)
	return o
}

// SetCredentialsRequest adds the credentialsRequest to the post credentials params
func (o *PostCredentialsParams) SetCredentialsRequest(credentialsRequest *auth0_models.CredentialsRequest) {
	o.CredentialsRequest = credentialsRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PostCredentialsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.CredentialsRequest != nil {
		if err := r.SetBodyParam(o.CredentialsRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
