// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package user

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/auth0/auth0_models"
)

// PostUsersReader is a Reader for the PostUsers structure.
type PostUsersReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostUsersReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 201:
		result := NewPostUsersCreated()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostUsersUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostUsersForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostUsersNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 409:
		result := NewPostUsersConflict()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostUsersInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewPostUsersCreated creates a PostUsersCreated with default headers values
func NewPostUsersCreated() *PostUsersCreated {
	return &PostUsersCreated{}
}

/*
PostUsersCreated describes a response with status code 201, with default header values.

New user created
*/
type PostUsersCreated struct {
}

// IsSuccess returns true when this post users created response has a 2xx status code
func (o *PostUsersCreated) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this post users created response has a 3xx status code
func (o *PostUsersCreated) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post users created response has a 4xx status code
func (o *PostUsersCreated) IsClientError() bool {
	return false
}

// IsServerError returns true when this post users created response has a 5xx status code
func (o *PostUsersCreated) IsServerError() bool {
	return false
}

// IsCode returns true when this post users created response a status code equal to that given
func (o *PostUsersCreated) IsCode(code int) bool {
	return code == 201
}

// Code gets the status code for the post users created response
func (o *PostUsersCreated) Code() int {
	return 201
}

func (o *PostUsersCreated) Error() string {
	return fmt.Sprintf("[POST /api/v2/users-by-email][%d] postUsersCreated ", 201)
}

func (o *PostUsersCreated) String() string {
	return fmt.Sprintf("[POST /api/v2/users-by-email][%d] postUsersCreated ", 201)
}

func (o *PostUsersCreated) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewPostUsersUnauthorized creates a PostUsersUnauthorized with default headers values
func NewPostUsersUnauthorized() *PostUsersUnauthorized {
	return &PostUsersUnauthorized{}
}

/*
PostUsersUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type PostUsersUnauthorized struct {
	Payload *auth0_models.Error
}

// IsSuccess returns true when this post users unauthorized response has a 2xx status code
func (o *PostUsersUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post users unauthorized response has a 3xx status code
func (o *PostUsersUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post users unauthorized response has a 4xx status code
func (o *PostUsersUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this post users unauthorized response has a 5xx status code
func (o *PostUsersUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this post users unauthorized response a status code equal to that given
func (o *PostUsersUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the post users unauthorized response
func (o *PostUsersUnauthorized) Code() int {
	return 401
}

func (o *PostUsersUnauthorized) Error() string {
	return fmt.Sprintf("[POST /api/v2/users-by-email][%d] postUsersUnauthorized  %+v", 401, o.Payload)
}

func (o *PostUsersUnauthorized) String() string {
	return fmt.Sprintf("[POST /api/v2/users-by-email][%d] postUsersUnauthorized  %+v", 401, o.Payload)
}

func (o *PostUsersUnauthorized) GetPayload() *auth0_models.Error {
	return o.Payload
}

func (o *PostUsersUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(auth0_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostUsersForbidden creates a PostUsersForbidden with default headers values
func NewPostUsersForbidden() *PostUsersForbidden {
	return &PostUsersForbidden{}
}

/*
PostUsersForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type PostUsersForbidden struct {
	Payload *auth0_models.Error
}

// IsSuccess returns true when this post users forbidden response has a 2xx status code
func (o *PostUsersForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post users forbidden response has a 3xx status code
func (o *PostUsersForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post users forbidden response has a 4xx status code
func (o *PostUsersForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this post users forbidden response has a 5xx status code
func (o *PostUsersForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this post users forbidden response a status code equal to that given
func (o *PostUsersForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the post users forbidden response
func (o *PostUsersForbidden) Code() int {
	return 403
}

func (o *PostUsersForbidden) Error() string {
	return fmt.Sprintf("[POST /api/v2/users-by-email][%d] postUsersForbidden  %+v", 403, o.Payload)
}

func (o *PostUsersForbidden) String() string {
	return fmt.Sprintf("[POST /api/v2/users-by-email][%d] postUsersForbidden  %+v", 403, o.Payload)
}

func (o *PostUsersForbidden) GetPayload() *auth0_models.Error {
	return o.Payload
}

func (o *PostUsersForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(auth0_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostUsersNotFound creates a PostUsersNotFound with default headers values
func NewPostUsersNotFound() *PostUsersNotFound {
	return &PostUsersNotFound{}
}

/*
PostUsersNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type PostUsersNotFound struct {
	Payload *auth0_models.Error
}

// IsSuccess returns true when this post users not found response has a 2xx status code
func (o *PostUsersNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post users not found response has a 3xx status code
func (o *PostUsersNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post users not found response has a 4xx status code
func (o *PostUsersNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this post users not found response has a 5xx status code
func (o *PostUsersNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this post users not found response a status code equal to that given
func (o *PostUsersNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the post users not found response
func (o *PostUsersNotFound) Code() int {
	return 404
}

func (o *PostUsersNotFound) Error() string {
	return fmt.Sprintf("[POST /api/v2/users-by-email][%d] postUsersNotFound  %+v", 404, o.Payload)
}

func (o *PostUsersNotFound) String() string {
	return fmt.Sprintf("[POST /api/v2/users-by-email][%d] postUsersNotFound  %+v", 404, o.Payload)
}

func (o *PostUsersNotFound) GetPayload() *auth0_models.Error {
	return o.Payload
}

func (o *PostUsersNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(auth0_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostUsersConflict creates a PostUsersConflict with default headers values
func NewPostUsersConflict() *PostUsersConflict {
	return &PostUsersConflict{}
}

/*
PostUsersConflict describes a response with status code 409, with default header values.

User already exists
*/
type PostUsersConflict struct {
}

// IsSuccess returns true when this post users conflict response has a 2xx status code
func (o *PostUsersConflict) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post users conflict response has a 3xx status code
func (o *PostUsersConflict) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post users conflict response has a 4xx status code
func (o *PostUsersConflict) IsClientError() bool {
	return true
}

// IsServerError returns true when this post users conflict response has a 5xx status code
func (o *PostUsersConflict) IsServerError() bool {
	return false
}

// IsCode returns true when this post users conflict response a status code equal to that given
func (o *PostUsersConflict) IsCode(code int) bool {
	return code == 409
}

// Code gets the status code for the post users conflict response
func (o *PostUsersConflict) Code() int {
	return 409
}

func (o *PostUsersConflict) Error() string {
	return fmt.Sprintf("[POST /api/v2/users-by-email][%d] postUsersConflict ", 409)
}

func (o *PostUsersConflict) String() string {
	return fmt.Sprintf("[POST /api/v2/users-by-email][%d] postUsersConflict ", 409)
}

func (o *PostUsersConflict) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewPostUsersInternalServerError creates a PostUsersInternalServerError with default headers values
func NewPostUsersInternalServerError() *PostUsersInternalServerError {
	return &PostUsersInternalServerError{}
}

/*
PostUsersInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type PostUsersInternalServerError struct {
	Payload *auth0_models.Error
}

// IsSuccess returns true when this post users internal server error response has a 2xx status code
func (o *PostUsersInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post users internal server error response has a 3xx status code
func (o *PostUsersInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post users internal server error response has a 4xx status code
func (o *PostUsersInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this post users internal server error response has a 5xx status code
func (o *PostUsersInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this post users internal server error response a status code equal to that given
func (o *PostUsersInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the post users internal server error response
func (o *PostUsersInternalServerError) Code() int {
	return 500
}

func (o *PostUsersInternalServerError) Error() string {
	return fmt.Sprintf("[POST /api/v2/users-by-email][%d] postUsersInternalServerError  %+v", 500, o.Payload)
}

func (o *PostUsersInternalServerError) String() string {
	return fmt.Sprintf("[POST /api/v2/users-by-email][%d] postUsersInternalServerError  %+v", 500, o.Payload)
}

func (o *PostUsersInternalServerError) GetPayload() *auth0_models.Error {
	return o.Payload
}

func (o *PostUsersInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(auth0_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
