// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package accounts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/crm/crm_models"
)

// GetAccountsObservableReader is a Reader for the GetAccountsObservable structure.
type GetAccountsObservableReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetAccountsObservableReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetAccountsObservableOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetAccountsObservableUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetAccountsObservableForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetAccountsObservableNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetAccountsObservableUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetAccountsObservableInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetAccountsObservableOK creates a GetAccountsObservableOK with default headers values
func NewGetAccountsObservableOK() *GetAccountsObservableOK {
	return &GetAccountsObservableOK{}
}

/*
GetAccountsObservableOK describes a response with status code 200, with default header values.

Taxnexus Response with an array of Account objects
*/
type GetAccountsObservableOK struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload []*crm_models.Account
}

// IsSuccess returns true when this get accounts observable o k response has a 2xx status code
func (o *GetAccountsObservableOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get accounts observable o k response has a 3xx status code
func (o *GetAccountsObservableOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get accounts observable o k response has a 4xx status code
func (o *GetAccountsObservableOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get accounts observable o k response has a 5xx status code
func (o *GetAccountsObservableOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get accounts observable o k response a status code equal to that given
func (o *GetAccountsObservableOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get accounts observable o k response
func (o *GetAccountsObservableOK) Code() int {
	return 200
}

func (o *GetAccountsObservableOK) Error() string {
	return fmt.Sprintf("[GET /accounts/observable][%d] getAccountsObservableOK  %+v", 200, o.Payload)
}

func (o *GetAccountsObservableOK) String() string {
	return fmt.Sprintf("[GET /accounts/observable][%d] getAccountsObservableOK  %+v", 200, o.Payload)
}

func (o *GetAccountsObservableOK) GetPayload() []*crm_models.Account {
	return o.Payload
}

func (o *GetAccountsObservableOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAccountsObservableUnauthorized creates a GetAccountsObservableUnauthorized with default headers values
func NewGetAccountsObservableUnauthorized() *GetAccountsObservableUnauthorized {
	return &GetAccountsObservableUnauthorized{}
}

/*
GetAccountsObservableUnauthorized describes a response with status code 401, with default header values.

Access unauthorized, invalid API-KEY was used
*/
type GetAccountsObservableUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

// IsSuccess returns true when this get accounts observable unauthorized response has a 2xx status code
func (o *GetAccountsObservableUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get accounts observable unauthorized response has a 3xx status code
func (o *GetAccountsObservableUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get accounts observable unauthorized response has a 4xx status code
func (o *GetAccountsObservableUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this get accounts observable unauthorized response has a 5xx status code
func (o *GetAccountsObservableUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this get accounts observable unauthorized response a status code equal to that given
func (o *GetAccountsObservableUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the get accounts observable unauthorized response
func (o *GetAccountsObservableUnauthorized) Code() int {
	return 401
}

func (o *GetAccountsObservableUnauthorized) Error() string {
	return fmt.Sprintf("[GET /accounts/observable][%d] getAccountsObservableUnauthorized  %+v", 401, o.Payload)
}

func (o *GetAccountsObservableUnauthorized) String() string {
	return fmt.Sprintf("[GET /accounts/observable][%d] getAccountsObservableUnauthorized  %+v", 401, o.Payload)
}

func (o *GetAccountsObservableUnauthorized) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetAccountsObservableUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAccountsObservableForbidden creates a GetAccountsObservableForbidden with default headers values
func NewGetAccountsObservableForbidden() *GetAccountsObservableForbidden {
	return &GetAccountsObservableForbidden{}
}

/*
GetAccountsObservableForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type GetAccountsObservableForbidden struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

// IsSuccess returns true when this get accounts observable forbidden response has a 2xx status code
func (o *GetAccountsObservableForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get accounts observable forbidden response has a 3xx status code
func (o *GetAccountsObservableForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get accounts observable forbidden response has a 4xx status code
func (o *GetAccountsObservableForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this get accounts observable forbidden response has a 5xx status code
func (o *GetAccountsObservableForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this get accounts observable forbidden response a status code equal to that given
func (o *GetAccountsObservableForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the get accounts observable forbidden response
func (o *GetAccountsObservableForbidden) Code() int {
	return 403
}

func (o *GetAccountsObservableForbidden) Error() string {
	return fmt.Sprintf("[GET /accounts/observable][%d] getAccountsObservableForbidden  %+v", 403, o.Payload)
}

func (o *GetAccountsObservableForbidden) String() string {
	return fmt.Sprintf("[GET /accounts/observable][%d] getAccountsObservableForbidden  %+v", 403, o.Payload)
}

func (o *GetAccountsObservableForbidden) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetAccountsObservableForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAccountsObservableNotFound creates a GetAccountsObservableNotFound with default headers values
func NewGetAccountsObservableNotFound() *GetAccountsObservableNotFound {
	return &GetAccountsObservableNotFound{}
}

/*
GetAccountsObservableNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type GetAccountsObservableNotFound struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

// IsSuccess returns true when this get accounts observable not found response has a 2xx status code
func (o *GetAccountsObservableNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get accounts observable not found response has a 3xx status code
func (o *GetAccountsObservableNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get accounts observable not found response has a 4xx status code
func (o *GetAccountsObservableNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this get accounts observable not found response has a 5xx status code
func (o *GetAccountsObservableNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this get accounts observable not found response a status code equal to that given
func (o *GetAccountsObservableNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the get accounts observable not found response
func (o *GetAccountsObservableNotFound) Code() int {
	return 404
}

func (o *GetAccountsObservableNotFound) Error() string {
	return fmt.Sprintf("[GET /accounts/observable][%d] getAccountsObservableNotFound  %+v", 404, o.Payload)
}

func (o *GetAccountsObservableNotFound) String() string {
	return fmt.Sprintf("[GET /accounts/observable][%d] getAccountsObservableNotFound  %+v", 404, o.Payload)
}

func (o *GetAccountsObservableNotFound) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetAccountsObservableNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAccountsObservableUnprocessableEntity creates a GetAccountsObservableUnprocessableEntity with default headers values
func NewGetAccountsObservableUnprocessableEntity() *GetAccountsObservableUnprocessableEntity {
	return &GetAccountsObservableUnprocessableEntity{}
}

/*
GetAccountsObservableUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetAccountsObservableUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

// IsSuccess returns true when this get accounts observable unprocessable entity response has a 2xx status code
func (o *GetAccountsObservableUnprocessableEntity) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get accounts observable unprocessable entity response has a 3xx status code
func (o *GetAccountsObservableUnprocessableEntity) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get accounts observable unprocessable entity response has a 4xx status code
func (o *GetAccountsObservableUnprocessableEntity) IsClientError() bool {
	return true
}

// IsServerError returns true when this get accounts observable unprocessable entity response has a 5xx status code
func (o *GetAccountsObservableUnprocessableEntity) IsServerError() bool {
	return false
}

// IsCode returns true when this get accounts observable unprocessable entity response a status code equal to that given
func (o *GetAccountsObservableUnprocessableEntity) IsCode(code int) bool {
	return code == 422
}

// Code gets the status code for the get accounts observable unprocessable entity response
func (o *GetAccountsObservableUnprocessableEntity) Code() int {
	return 422
}

func (o *GetAccountsObservableUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /accounts/observable][%d] getAccountsObservableUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetAccountsObservableUnprocessableEntity) String() string {
	return fmt.Sprintf("[GET /accounts/observable][%d] getAccountsObservableUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetAccountsObservableUnprocessableEntity) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetAccountsObservableUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAccountsObservableInternalServerError creates a GetAccountsObservableInternalServerError with default headers values
func NewGetAccountsObservableInternalServerError() *GetAccountsObservableInternalServerError {
	return &GetAccountsObservableInternalServerError{}
}

/*
GetAccountsObservableInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type GetAccountsObservableInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

// IsSuccess returns true when this get accounts observable internal server error response has a 2xx status code
func (o *GetAccountsObservableInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get accounts observable internal server error response has a 3xx status code
func (o *GetAccountsObservableInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get accounts observable internal server error response has a 4xx status code
func (o *GetAccountsObservableInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this get accounts observable internal server error response has a 5xx status code
func (o *GetAccountsObservableInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this get accounts observable internal server error response a status code equal to that given
func (o *GetAccountsObservableInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the get accounts observable internal server error response
func (o *GetAccountsObservableInternalServerError) Code() int {
	return 500
}

func (o *GetAccountsObservableInternalServerError) Error() string {
	return fmt.Sprintf("[GET /accounts/observable][%d] getAccountsObservableInternalServerError  %+v", 500, o.Payload)
}

func (o *GetAccountsObservableInternalServerError) String() string {
	return fmt.Sprintf("[GET /accounts/observable][%d] getAccountsObservableInternalServerError  %+v", 500, o.Payload)
}

func (o *GetAccountsObservableInternalServerError) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetAccountsObservableInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
