// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package accounts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/crm/crm_models"
)

// PostAccountsReader is a Reader for the PostAccounts structure.
type PostAccountsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostAccountsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostAccountsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostAccountsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostAccountsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostAccountsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPostAccountsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostAccountsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewPostAccountsOK creates a PostAccountsOK with default headers values
func NewPostAccountsOK() *PostAccountsOK {
	return &PostAccountsOK{}
}

/*
PostAccountsOK describes a response with status code 200, with default header values.

Taxnexus Response with Account objects with Contacts
*/
type PostAccountsOK struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *crm_models.AccountResponse
}

// IsSuccess returns true when this post accounts o k response has a 2xx status code
func (o *PostAccountsOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this post accounts o k response has a 3xx status code
func (o *PostAccountsOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post accounts o k response has a 4xx status code
func (o *PostAccountsOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this post accounts o k response has a 5xx status code
func (o *PostAccountsOK) IsServerError() bool {
	return false
}

// IsCode returns true when this post accounts o k response a status code equal to that given
func (o *PostAccountsOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the post accounts o k response
func (o *PostAccountsOK) Code() int {
	return 200
}

func (o *PostAccountsOK) Error() string {
	return fmt.Sprintf("[POST /accounts][%d] postAccountsOK  %+v", 200, o.Payload)
}

func (o *PostAccountsOK) String() string {
	return fmt.Sprintf("[POST /accounts][%d] postAccountsOK  %+v", 200, o.Payload)
}

func (o *PostAccountsOK) GetPayload() *crm_models.AccountResponse {
	return o.Payload
}

func (o *PostAccountsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(crm_models.AccountResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostAccountsUnauthorized creates a PostAccountsUnauthorized with default headers values
func NewPostAccountsUnauthorized() *PostAccountsUnauthorized {
	return &PostAccountsUnauthorized{}
}

/*
PostAccountsUnauthorized describes a response with status code 401, with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PostAccountsUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

// IsSuccess returns true when this post accounts unauthorized response has a 2xx status code
func (o *PostAccountsUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post accounts unauthorized response has a 3xx status code
func (o *PostAccountsUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post accounts unauthorized response has a 4xx status code
func (o *PostAccountsUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this post accounts unauthorized response has a 5xx status code
func (o *PostAccountsUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this post accounts unauthorized response a status code equal to that given
func (o *PostAccountsUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the post accounts unauthorized response
func (o *PostAccountsUnauthorized) Code() int {
	return 401
}

func (o *PostAccountsUnauthorized) Error() string {
	return fmt.Sprintf("[POST /accounts][%d] postAccountsUnauthorized  %+v", 401, o.Payload)
}

func (o *PostAccountsUnauthorized) String() string {
	return fmt.Sprintf("[POST /accounts][%d] postAccountsUnauthorized  %+v", 401, o.Payload)
}

func (o *PostAccountsUnauthorized) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *PostAccountsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostAccountsForbidden creates a PostAccountsForbidden with default headers values
func NewPostAccountsForbidden() *PostAccountsForbidden {
	return &PostAccountsForbidden{}
}

/*
PostAccountsForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type PostAccountsForbidden struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

// IsSuccess returns true when this post accounts forbidden response has a 2xx status code
func (o *PostAccountsForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post accounts forbidden response has a 3xx status code
func (o *PostAccountsForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post accounts forbidden response has a 4xx status code
func (o *PostAccountsForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this post accounts forbidden response has a 5xx status code
func (o *PostAccountsForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this post accounts forbidden response a status code equal to that given
func (o *PostAccountsForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the post accounts forbidden response
func (o *PostAccountsForbidden) Code() int {
	return 403
}

func (o *PostAccountsForbidden) Error() string {
	return fmt.Sprintf("[POST /accounts][%d] postAccountsForbidden  %+v", 403, o.Payload)
}

func (o *PostAccountsForbidden) String() string {
	return fmt.Sprintf("[POST /accounts][%d] postAccountsForbidden  %+v", 403, o.Payload)
}

func (o *PostAccountsForbidden) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *PostAccountsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostAccountsNotFound creates a PostAccountsNotFound with default headers values
func NewPostAccountsNotFound() *PostAccountsNotFound {
	return &PostAccountsNotFound{}
}

/*
PostAccountsNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type PostAccountsNotFound struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

// IsSuccess returns true when this post accounts not found response has a 2xx status code
func (o *PostAccountsNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post accounts not found response has a 3xx status code
func (o *PostAccountsNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post accounts not found response has a 4xx status code
func (o *PostAccountsNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this post accounts not found response has a 5xx status code
func (o *PostAccountsNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this post accounts not found response a status code equal to that given
func (o *PostAccountsNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the post accounts not found response
func (o *PostAccountsNotFound) Code() int {
	return 404
}

func (o *PostAccountsNotFound) Error() string {
	return fmt.Sprintf("[POST /accounts][%d] postAccountsNotFound  %+v", 404, o.Payload)
}

func (o *PostAccountsNotFound) String() string {
	return fmt.Sprintf("[POST /accounts][%d] postAccountsNotFound  %+v", 404, o.Payload)
}

func (o *PostAccountsNotFound) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *PostAccountsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostAccountsUnprocessableEntity creates a PostAccountsUnprocessableEntity with default headers values
func NewPostAccountsUnprocessableEntity() *PostAccountsUnprocessableEntity {
	return &PostAccountsUnprocessableEntity{}
}

/*
PostAccountsUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PostAccountsUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

// IsSuccess returns true when this post accounts unprocessable entity response has a 2xx status code
func (o *PostAccountsUnprocessableEntity) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post accounts unprocessable entity response has a 3xx status code
func (o *PostAccountsUnprocessableEntity) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post accounts unprocessable entity response has a 4xx status code
func (o *PostAccountsUnprocessableEntity) IsClientError() bool {
	return true
}

// IsServerError returns true when this post accounts unprocessable entity response has a 5xx status code
func (o *PostAccountsUnprocessableEntity) IsServerError() bool {
	return false
}

// IsCode returns true when this post accounts unprocessable entity response a status code equal to that given
func (o *PostAccountsUnprocessableEntity) IsCode(code int) bool {
	return code == 422
}

// Code gets the status code for the post accounts unprocessable entity response
func (o *PostAccountsUnprocessableEntity) Code() int {
	return 422
}

func (o *PostAccountsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[POST /accounts][%d] postAccountsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PostAccountsUnprocessableEntity) String() string {
	return fmt.Sprintf("[POST /accounts][%d] postAccountsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PostAccountsUnprocessableEntity) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *PostAccountsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostAccountsInternalServerError creates a PostAccountsInternalServerError with default headers values
func NewPostAccountsInternalServerError() *PostAccountsInternalServerError {
	return &PostAccountsInternalServerError{}
}

/*
PostAccountsInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type PostAccountsInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

// IsSuccess returns true when this post accounts internal server error response has a 2xx status code
func (o *PostAccountsInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post accounts internal server error response has a 3xx status code
func (o *PostAccountsInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post accounts internal server error response has a 4xx status code
func (o *PostAccountsInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this post accounts internal server error response has a 5xx status code
func (o *PostAccountsInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this post accounts internal server error response a status code equal to that given
func (o *PostAccountsInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the post accounts internal server error response
func (o *PostAccountsInternalServerError) Code() int {
	return 500
}

func (o *PostAccountsInternalServerError) Error() string {
	return fmt.Sprintf("[POST /accounts][%d] postAccountsInternalServerError  %+v", 500, o.Payload)
}

func (o *PostAccountsInternalServerError) String() string {
	return fmt.Sprintf("[POST /accounts][%d] postAccountsInternalServerError  %+v", 500, o.Payload)
}

func (o *PostAccountsInternalServerError) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *PostAccountsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
