// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package contacts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/crm/crm_models"
)

// GetContactsObservableReader is a Reader for the GetContactsObservable structure.
type GetContactsObservableReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetContactsObservableReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetContactsObservableOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetContactsObservableUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetContactsObservableForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetContactsObservableNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetContactsObservableUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetContactsObservableInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetContactsObservableOK creates a GetContactsObservableOK with default headers values
func NewGetContactsObservableOK() *GetContactsObservableOK {
	return &GetContactsObservableOK{}
}

/*
GetContactsObservableOK describes a response with status code 200, with default header values.

Taxnexus Response with an array of Contact objects
*/
type GetContactsObservableOK struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload []*crm_models.Contact
}

// IsSuccess returns true when this get contacts observable o k response has a 2xx status code
func (o *GetContactsObservableOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get contacts observable o k response has a 3xx status code
func (o *GetContactsObservableOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get contacts observable o k response has a 4xx status code
func (o *GetContactsObservableOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get contacts observable o k response has a 5xx status code
func (o *GetContactsObservableOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get contacts observable o k response a status code equal to that given
func (o *GetContactsObservableOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get contacts observable o k response
func (o *GetContactsObservableOK) Code() int {
	return 200
}

func (o *GetContactsObservableOK) Error() string {
	return fmt.Sprintf("[GET /contacts/observable][%d] getContactsObservableOK  %+v", 200, o.Payload)
}

func (o *GetContactsObservableOK) String() string {
	return fmt.Sprintf("[GET /contacts/observable][%d] getContactsObservableOK  %+v", 200, o.Payload)
}

func (o *GetContactsObservableOK) GetPayload() []*crm_models.Contact {
	return o.Payload
}

func (o *GetContactsObservableOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetContactsObservableUnauthorized creates a GetContactsObservableUnauthorized with default headers values
func NewGetContactsObservableUnauthorized() *GetContactsObservableUnauthorized {
	return &GetContactsObservableUnauthorized{}
}

/*
GetContactsObservableUnauthorized describes a response with status code 401, with default header values.

Access unauthorized, invalid API-KEY was used
*/
type GetContactsObservableUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

// IsSuccess returns true when this get contacts observable unauthorized response has a 2xx status code
func (o *GetContactsObservableUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get contacts observable unauthorized response has a 3xx status code
func (o *GetContactsObservableUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get contacts observable unauthorized response has a 4xx status code
func (o *GetContactsObservableUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this get contacts observable unauthorized response has a 5xx status code
func (o *GetContactsObservableUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this get contacts observable unauthorized response a status code equal to that given
func (o *GetContactsObservableUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the get contacts observable unauthorized response
func (o *GetContactsObservableUnauthorized) Code() int {
	return 401
}

func (o *GetContactsObservableUnauthorized) Error() string {
	return fmt.Sprintf("[GET /contacts/observable][%d] getContactsObservableUnauthorized  %+v", 401, o.Payload)
}

func (o *GetContactsObservableUnauthorized) String() string {
	return fmt.Sprintf("[GET /contacts/observable][%d] getContactsObservableUnauthorized  %+v", 401, o.Payload)
}

func (o *GetContactsObservableUnauthorized) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetContactsObservableUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetContactsObservableForbidden creates a GetContactsObservableForbidden with default headers values
func NewGetContactsObservableForbidden() *GetContactsObservableForbidden {
	return &GetContactsObservableForbidden{}
}

/*
GetContactsObservableForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type GetContactsObservableForbidden struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

// IsSuccess returns true when this get contacts observable forbidden response has a 2xx status code
func (o *GetContactsObservableForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get contacts observable forbidden response has a 3xx status code
func (o *GetContactsObservableForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get contacts observable forbidden response has a 4xx status code
func (o *GetContactsObservableForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this get contacts observable forbidden response has a 5xx status code
func (o *GetContactsObservableForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this get contacts observable forbidden response a status code equal to that given
func (o *GetContactsObservableForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the get contacts observable forbidden response
func (o *GetContactsObservableForbidden) Code() int {
	return 403
}

func (o *GetContactsObservableForbidden) Error() string {
	return fmt.Sprintf("[GET /contacts/observable][%d] getContactsObservableForbidden  %+v", 403, o.Payload)
}

func (o *GetContactsObservableForbidden) String() string {
	return fmt.Sprintf("[GET /contacts/observable][%d] getContactsObservableForbidden  %+v", 403, o.Payload)
}

func (o *GetContactsObservableForbidden) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetContactsObservableForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetContactsObservableNotFound creates a GetContactsObservableNotFound with default headers values
func NewGetContactsObservableNotFound() *GetContactsObservableNotFound {
	return &GetContactsObservableNotFound{}
}

/*
GetContactsObservableNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type GetContactsObservableNotFound struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

// IsSuccess returns true when this get contacts observable not found response has a 2xx status code
func (o *GetContactsObservableNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get contacts observable not found response has a 3xx status code
func (o *GetContactsObservableNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get contacts observable not found response has a 4xx status code
func (o *GetContactsObservableNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this get contacts observable not found response has a 5xx status code
func (o *GetContactsObservableNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this get contacts observable not found response a status code equal to that given
func (o *GetContactsObservableNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the get contacts observable not found response
func (o *GetContactsObservableNotFound) Code() int {
	return 404
}

func (o *GetContactsObservableNotFound) Error() string {
	return fmt.Sprintf("[GET /contacts/observable][%d] getContactsObservableNotFound  %+v", 404, o.Payload)
}

func (o *GetContactsObservableNotFound) String() string {
	return fmt.Sprintf("[GET /contacts/observable][%d] getContactsObservableNotFound  %+v", 404, o.Payload)
}

func (o *GetContactsObservableNotFound) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetContactsObservableNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetContactsObservableUnprocessableEntity creates a GetContactsObservableUnprocessableEntity with default headers values
func NewGetContactsObservableUnprocessableEntity() *GetContactsObservableUnprocessableEntity {
	return &GetContactsObservableUnprocessableEntity{}
}

/*
GetContactsObservableUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetContactsObservableUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

// IsSuccess returns true when this get contacts observable unprocessable entity response has a 2xx status code
func (o *GetContactsObservableUnprocessableEntity) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get contacts observable unprocessable entity response has a 3xx status code
func (o *GetContactsObservableUnprocessableEntity) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get contacts observable unprocessable entity response has a 4xx status code
func (o *GetContactsObservableUnprocessableEntity) IsClientError() bool {
	return true
}

// IsServerError returns true when this get contacts observable unprocessable entity response has a 5xx status code
func (o *GetContactsObservableUnprocessableEntity) IsServerError() bool {
	return false
}

// IsCode returns true when this get contacts observable unprocessable entity response a status code equal to that given
func (o *GetContactsObservableUnprocessableEntity) IsCode(code int) bool {
	return code == 422
}

// Code gets the status code for the get contacts observable unprocessable entity response
func (o *GetContactsObservableUnprocessableEntity) Code() int {
	return 422
}

func (o *GetContactsObservableUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /contacts/observable][%d] getContactsObservableUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetContactsObservableUnprocessableEntity) String() string {
	return fmt.Sprintf("[GET /contacts/observable][%d] getContactsObservableUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetContactsObservableUnprocessableEntity) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetContactsObservableUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetContactsObservableInternalServerError creates a GetContactsObservableInternalServerError with default headers values
func NewGetContactsObservableInternalServerError() *GetContactsObservableInternalServerError {
	return &GetContactsObservableInternalServerError{}
}

/*
GetContactsObservableInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type GetContactsObservableInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

// IsSuccess returns true when this get contacts observable internal server error response has a 2xx status code
func (o *GetContactsObservableInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get contacts observable internal server error response has a 3xx status code
func (o *GetContactsObservableInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get contacts observable internal server error response has a 4xx status code
func (o *GetContactsObservableInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this get contacts observable internal server error response has a 5xx status code
func (o *GetContactsObservableInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this get contacts observable internal server error response a status code equal to that given
func (o *GetContactsObservableInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the get contacts observable internal server error response
func (o *GetContactsObservableInternalServerError) Code() int {
	return 500
}

func (o *GetContactsObservableInternalServerError) Error() string {
	return fmt.Sprintf("[GET /contacts/observable][%d] getContactsObservableInternalServerError  %+v", 500, o.Payload)
}

func (o *GetContactsObservableInternalServerError) String() string {
	return fmt.Sprintf("[GET /contacts/observable][%d] getContactsObservableInternalServerError  %+v", 500, o.Payload)
}

func (o *GetContactsObservableInternalServerError) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetContactsObservableInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
