// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package contracts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/crm/crm_models"
)

// PostContractsReader is a Reader for the PostContracts structure.
type PostContractsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostContractsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostContractsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostContractsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostContractsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostContractsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPostContractsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostContractsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewPostContractsOK creates a PostContractsOK with default headers values
func NewPostContractsOK() *PostContractsOK {
	return &PostContractsOK{}
}

/*
PostContractsOK describes a response with status code 200, with default header values.

Taxnexus Response with an array of Contract objects
*/
type PostContractsOK struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *crm_models.ContractResponse
}

// IsSuccess returns true when this post contracts o k response has a 2xx status code
func (o *PostContractsOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this post contracts o k response has a 3xx status code
func (o *PostContractsOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post contracts o k response has a 4xx status code
func (o *PostContractsOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this post contracts o k response has a 5xx status code
func (o *PostContractsOK) IsServerError() bool {
	return false
}

// IsCode returns true when this post contracts o k response a status code equal to that given
func (o *PostContractsOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the post contracts o k response
func (o *PostContractsOK) Code() int {
	return 200
}

func (o *PostContractsOK) Error() string {
	return fmt.Sprintf("[POST /contracts][%d] postContractsOK  %+v", 200, o.Payload)
}

func (o *PostContractsOK) String() string {
	return fmt.Sprintf("[POST /contracts][%d] postContractsOK  %+v", 200, o.Payload)
}

func (o *PostContractsOK) GetPayload() *crm_models.ContractResponse {
	return o.Payload
}

func (o *PostContractsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(crm_models.ContractResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostContractsUnauthorized creates a PostContractsUnauthorized with default headers values
func NewPostContractsUnauthorized() *PostContractsUnauthorized {
	return &PostContractsUnauthorized{}
}

/*
PostContractsUnauthorized describes a response with status code 401, with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PostContractsUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

// IsSuccess returns true when this post contracts unauthorized response has a 2xx status code
func (o *PostContractsUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post contracts unauthorized response has a 3xx status code
func (o *PostContractsUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post contracts unauthorized response has a 4xx status code
func (o *PostContractsUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this post contracts unauthorized response has a 5xx status code
func (o *PostContractsUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this post contracts unauthorized response a status code equal to that given
func (o *PostContractsUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the post contracts unauthorized response
func (o *PostContractsUnauthorized) Code() int {
	return 401
}

func (o *PostContractsUnauthorized) Error() string {
	return fmt.Sprintf("[POST /contracts][%d] postContractsUnauthorized  %+v", 401, o.Payload)
}

func (o *PostContractsUnauthorized) String() string {
	return fmt.Sprintf("[POST /contracts][%d] postContractsUnauthorized  %+v", 401, o.Payload)
}

func (o *PostContractsUnauthorized) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *PostContractsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostContractsForbidden creates a PostContractsForbidden with default headers values
func NewPostContractsForbidden() *PostContractsForbidden {
	return &PostContractsForbidden{}
}

/*
PostContractsForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type PostContractsForbidden struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

// IsSuccess returns true when this post contracts forbidden response has a 2xx status code
func (o *PostContractsForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post contracts forbidden response has a 3xx status code
func (o *PostContractsForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post contracts forbidden response has a 4xx status code
func (o *PostContractsForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this post contracts forbidden response has a 5xx status code
func (o *PostContractsForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this post contracts forbidden response a status code equal to that given
func (o *PostContractsForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the post contracts forbidden response
func (o *PostContractsForbidden) Code() int {
	return 403
}

func (o *PostContractsForbidden) Error() string {
	return fmt.Sprintf("[POST /contracts][%d] postContractsForbidden  %+v", 403, o.Payload)
}

func (o *PostContractsForbidden) String() string {
	return fmt.Sprintf("[POST /contracts][%d] postContractsForbidden  %+v", 403, o.Payload)
}

func (o *PostContractsForbidden) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *PostContractsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostContractsNotFound creates a PostContractsNotFound with default headers values
func NewPostContractsNotFound() *PostContractsNotFound {
	return &PostContractsNotFound{}
}

/*
PostContractsNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type PostContractsNotFound struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

// IsSuccess returns true when this post contracts not found response has a 2xx status code
func (o *PostContractsNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post contracts not found response has a 3xx status code
func (o *PostContractsNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post contracts not found response has a 4xx status code
func (o *PostContractsNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this post contracts not found response has a 5xx status code
func (o *PostContractsNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this post contracts not found response a status code equal to that given
func (o *PostContractsNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the post contracts not found response
func (o *PostContractsNotFound) Code() int {
	return 404
}

func (o *PostContractsNotFound) Error() string {
	return fmt.Sprintf("[POST /contracts][%d] postContractsNotFound  %+v", 404, o.Payload)
}

func (o *PostContractsNotFound) String() string {
	return fmt.Sprintf("[POST /contracts][%d] postContractsNotFound  %+v", 404, o.Payload)
}

func (o *PostContractsNotFound) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *PostContractsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostContractsUnprocessableEntity creates a PostContractsUnprocessableEntity with default headers values
func NewPostContractsUnprocessableEntity() *PostContractsUnprocessableEntity {
	return &PostContractsUnprocessableEntity{}
}

/*
PostContractsUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PostContractsUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

// IsSuccess returns true when this post contracts unprocessable entity response has a 2xx status code
func (o *PostContractsUnprocessableEntity) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post contracts unprocessable entity response has a 3xx status code
func (o *PostContractsUnprocessableEntity) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post contracts unprocessable entity response has a 4xx status code
func (o *PostContractsUnprocessableEntity) IsClientError() bool {
	return true
}

// IsServerError returns true when this post contracts unprocessable entity response has a 5xx status code
func (o *PostContractsUnprocessableEntity) IsServerError() bool {
	return false
}

// IsCode returns true when this post contracts unprocessable entity response a status code equal to that given
func (o *PostContractsUnprocessableEntity) IsCode(code int) bool {
	return code == 422
}

// Code gets the status code for the post contracts unprocessable entity response
func (o *PostContractsUnprocessableEntity) Code() int {
	return 422
}

func (o *PostContractsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[POST /contracts][%d] postContractsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PostContractsUnprocessableEntity) String() string {
	return fmt.Sprintf("[POST /contracts][%d] postContractsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PostContractsUnprocessableEntity) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *PostContractsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostContractsInternalServerError creates a PostContractsInternalServerError with default headers values
func NewPostContractsInternalServerError() *PostContractsInternalServerError {
	return &PostContractsInternalServerError{}
}

/*
PostContractsInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type PostContractsInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

// IsSuccess returns true when this post contracts internal server error response has a 2xx status code
func (o *PostContractsInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post contracts internal server error response has a 3xx status code
func (o *PostContractsInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post contracts internal server error response has a 4xx status code
func (o *PostContractsInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this post contracts internal server error response has a 5xx status code
func (o *PostContractsInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this post contracts internal server error response a status code equal to that given
func (o *PostContractsInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the post contracts internal server error response
func (o *PostContractsInternalServerError) Code() int {
	return 500
}

func (o *PostContractsInternalServerError) Error() string {
	return fmt.Sprintf("[POST /contracts][%d] postContractsInternalServerError  %+v", 500, o.Payload)
}

func (o *PostContractsInternalServerError) String() string {
	return fmt.Sprintf("[POST /contracts][%d] postContractsInternalServerError  %+v", 500, o.Payload)
}

func (o *PostContractsInternalServerError) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *PostContractsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
