// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package cors

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// AssetOptionsReader is a Reader for the AssetOptions structure.
type AssetOptionsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *AssetOptionsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewAssetOptionsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewAssetOptionsOK creates a AssetOptionsOK with default headers values
func NewAssetOptionsOK() *AssetOptionsOK {
	return &AssetOptionsOK{}
}

/*
AssetOptionsOK describes a response with status code 200, with default header values.

CORS OPTIONS response
*/
type AssetOptionsOK struct {
	AccessControlAllowCredentials string
	AccessControlAllowHeaders     string
	AccessControlAllowMethods     string
	AccessControlAllowOrigin      string
	AccessControlExposeHeaders    string
	AccessControlMaxAge           string
	CacheControl                  string
}

// IsSuccess returns true when this asset options o k response has a 2xx status code
func (o *AssetOptionsOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this asset options o k response has a 3xx status code
func (o *AssetOptionsOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this asset options o k response has a 4xx status code
func (o *AssetOptionsOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this asset options o k response has a 5xx status code
func (o *AssetOptionsOK) IsServerError() bool {
	return false
}

// IsCode returns true when this asset options o k response a status code equal to that given
func (o *AssetOptionsOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the asset options o k response
func (o *AssetOptionsOK) Code() int {
	return 200
}

func (o *AssetOptionsOK) Error() string {
	return fmt.Sprintf("[OPTIONS /assets][%d] assetOptionsOK ", 200)
}

func (o *AssetOptionsOK) String() string {
	return fmt.Sprintf("[OPTIONS /assets][%d] assetOptionsOK ", 200)
}

func (o *AssetOptionsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Credentials
	hdrAccessControlAllowCredentials := response.GetHeader("Access-Control-Allow-Credentials")

	if hdrAccessControlAllowCredentials != "" {
		o.AccessControlAllowCredentials = hdrAccessControlAllowCredentials
	}

	// hydrates response header Access-Control-Allow-Headers
	hdrAccessControlAllowHeaders := response.GetHeader("Access-Control-Allow-Headers")

	if hdrAccessControlAllowHeaders != "" {
		o.AccessControlAllowHeaders = hdrAccessControlAllowHeaders
	}

	// hydrates response header Access-Control-Allow-Methods
	hdrAccessControlAllowMethods := response.GetHeader("Access-Control-Allow-Methods")

	if hdrAccessControlAllowMethods != "" {
		o.AccessControlAllowMethods = hdrAccessControlAllowMethods
	}

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Access-Control-Expose-Headers
	hdrAccessControlExposeHeaders := response.GetHeader("Access-Control-Expose-Headers")

	if hdrAccessControlExposeHeaders != "" {
		o.AccessControlExposeHeaders = hdrAccessControlExposeHeaders
	}

	// hydrates response header Access-Control-Max-Age
	hdrAccessControlMaxAge := response.GetHeader("Access-Control-Max-Age")

	if hdrAccessControlMaxAge != "" {
		o.AccessControlMaxAge = hdrAccessControlMaxAge
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	return nil
}
