// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package leads

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/crm/crm_models"
)

// GetLeadsObservableReader is a Reader for the GetLeadsObservable structure.
type GetLeadsObservableReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetLeadsObservableReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetLeadsObservableOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetLeadsObservableUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetLeadsObservableForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetLeadsObservableNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetLeadsObservableUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetLeadsObservableInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetLeadsObservableOK creates a GetLeadsObservableOK with default headers values
func NewGetLeadsObservableOK() *GetLeadsObservableOK {
	return &GetLeadsObservableOK{}
}

/*
GetLeadsObservableOK describes a response with status code 200, with default header values.

Taxnexus Response with an array of Lead objects
*/
type GetLeadsObservableOK struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload []*crm_models.Lead
}

// IsSuccess returns true when this get leads observable o k response has a 2xx status code
func (o *GetLeadsObservableOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get leads observable o k response has a 3xx status code
func (o *GetLeadsObservableOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get leads observable o k response has a 4xx status code
func (o *GetLeadsObservableOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get leads observable o k response has a 5xx status code
func (o *GetLeadsObservableOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get leads observable o k response a status code equal to that given
func (o *GetLeadsObservableOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get leads observable o k response
func (o *GetLeadsObservableOK) Code() int {
	return 200
}

func (o *GetLeadsObservableOK) Error() string {
	return fmt.Sprintf("[GET /leads/observable][%d] getLeadsObservableOK  %+v", 200, o.Payload)
}

func (o *GetLeadsObservableOK) String() string {
	return fmt.Sprintf("[GET /leads/observable][%d] getLeadsObservableOK  %+v", 200, o.Payload)
}

func (o *GetLeadsObservableOK) GetPayload() []*crm_models.Lead {
	return o.Payload
}

func (o *GetLeadsObservableOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetLeadsObservableUnauthorized creates a GetLeadsObservableUnauthorized with default headers values
func NewGetLeadsObservableUnauthorized() *GetLeadsObservableUnauthorized {
	return &GetLeadsObservableUnauthorized{}
}

/*
GetLeadsObservableUnauthorized describes a response with status code 401, with default header values.

Access unauthorized, invalid API-KEY was used
*/
type GetLeadsObservableUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

// IsSuccess returns true when this get leads observable unauthorized response has a 2xx status code
func (o *GetLeadsObservableUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get leads observable unauthorized response has a 3xx status code
func (o *GetLeadsObservableUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get leads observable unauthorized response has a 4xx status code
func (o *GetLeadsObservableUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this get leads observable unauthorized response has a 5xx status code
func (o *GetLeadsObservableUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this get leads observable unauthorized response a status code equal to that given
func (o *GetLeadsObservableUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the get leads observable unauthorized response
func (o *GetLeadsObservableUnauthorized) Code() int {
	return 401
}

func (o *GetLeadsObservableUnauthorized) Error() string {
	return fmt.Sprintf("[GET /leads/observable][%d] getLeadsObservableUnauthorized  %+v", 401, o.Payload)
}

func (o *GetLeadsObservableUnauthorized) String() string {
	return fmt.Sprintf("[GET /leads/observable][%d] getLeadsObservableUnauthorized  %+v", 401, o.Payload)
}

func (o *GetLeadsObservableUnauthorized) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetLeadsObservableUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetLeadsObservableForbidden creates a GetLeadsObservableForbidden with default headers values
func NewGetLeadsObservableForbidden() *GetLeadsObservableForbidden {
	return &GetLeadsObservableForbidden{}
}

/*
GetLeadsObservableForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type GetLeadsObservableForbidden struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

// IsSuccess returns true when this get leads observable forbidden response has a 2xx status code
func (o *GetLeadsObservableForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get leads observable forbidden response has a 3xx status code
func (o *GetLeadsObservableForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get leads observable forbidden response has a 4xx status code
func (o *GetLeadsObservableForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this get leads observable forbidden response has a 5xx status code
func (o *GetLeadsObservableForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this get leads observable forbidden response a status code equal to that given
func (o *GetLeadsObservableForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the get leads observable forbidden response
func (o *GetLeadsObservableForbidden) Code() int {
	return 403
}

func (o *GetLeadsObservableForbidden) Error() string {
	return fmt.Sprintf("[GET /leads/observable][%d] getLeadsObservableForbidden  %+v", 403, o.Payload)
}

func (o *GetLeadsObservableForbidden) String() string {
	return fmt.Sprintf("[GET /leads/observable][%d] getLeadsObservableForbidden  %+v", 403, o.Payload)
}

func (o *GetLeadsObservableForbidden) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetLeadsObservableForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetLeadsObservableNotFound creates a GetLeadsObservableNotFound with default headers values
func NewGetLeadsObservableNotFound() *GetLeadsObservableNotFound {
	return &GetLeadsObservableNotFound{}
}

/*
GetLeadsObservableNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type GetLeadsObservableNotFound struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

// IsSuccess returns true when this get leads observable not found response has a 2xx status code
func (o *GetLeadsObservableNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get leads observable not found response has a 3xx status code
func (o *GetLeadsObservableNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get leads observable not found response has a 4xx status code
func (o *GetLeadsObservableNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this get leads observable not found response has a 5xx status code
func (o *GetLeadsObservableNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this get leads observable not found response a status code equal to that given
func (o *GetLeadsObservableNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the get leads observable not found response
func (o *GetLeadsObservableNotFound) Code() int {
	return 404
}

func (o *GetLeadsObservableNotFound) Error() string {
	return fmt.Sprintf("[GET /leads/observable][%d] getLeadsObservableNotFound  %+v", 404, o.Payload)
}

func (o *GetLeadsObservableNotFound) String() string {
	return fmt.Sprintf("[GET /leads/observable][%d] getLeadsObservableNotFound  %+v", 404, o.Payload)
}

func (o *GetLeadsObservableNotFound) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetLeadsObservableNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetLeadsObservableUnprocessableEntity creates a GetLeadsObservableUnprocessableEntity with default headers values
func NewGetLeadsObservableUnprocessableEntity() *GetLeadsObservableUnprocessableEntity {
	return &GetLeadsObservableUnprocessableEntity{}
}

/*
GetLeadsObservableUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetLeadsObservableUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

// IsSuccess returns true when this get leads observable unprocessable entity response has a 2xx status code
func (o *GetLeadsObservableUnprocessableEntity) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get leads observable unprocessable entity response has a 3xx status code
func (o *GetLeadsObservableUnprocessableEntity) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get leads observable unprocessable entity response has a 4xx status code
func (o *GetLeadsObservableUnprocessableEntity) IsClientError() bool {
	return true
}

// IsServerError returns true when this get leads observable unprocessable entity response has a 5xx status code
func (o *GetLeadsObservableUnprocessableEntity) IsServerError() bool {
	return false
}

// IsCode returns true when this get leads observable unprocessable entity response a status code equal to that given
func (o *GetLeadsObservableUnprocessableEntity) IsCode(code int) bool {
	return code == 422
}

// Code gets the status code for the get leads observable unprocessable entity response
func (o *GetLeadsObservableUnprocessableEntity) Code() int {
	return 422
}

func (o *GetLeadsObservableUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /leads/observable][%d] getLeadsObservableUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetLeadsObservableUnprocessableEntity) String() string {
	return fmt.Sprintf("[GET /leads/observable][%d] getLeadsObservableUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetLeadsObservableUnprocessableEntity) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetLeadsObservableUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetLeadsObservableInternalServerError creates a GetLeadsObservableInternalServerError with default headers values
func NewGetLeadsObservableInternalServerError() *GetLeadsObservableInternalServerError {
	return &GetLeadsObservableInternalServerError{}
}

/*
GetLeadsObservableInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type GetLeadsObservableInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

// IsSuccess returns true when this get leads observable internal server error response has a 2xx status code
func (o *GetLeadsObservableInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get leads observable internal server error response has a 3xx status code
func (o *GetLeadsObservableInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get leads observable internal server error response has a 4xx status code
func (o *GetLeadsObservableInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this get leads observable internal server error response has a 5xx status code
func (o *GetLeadsObservableInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this get leads observable internal server error response a status code equal to that given
func (o *GetLeadsObservableInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the get leads observable internal server error response
func (o *GetLeadsObservableInternalServerError) Code() int {
	return 500
}

func (o *GetLeadsObservableInternalServerError) Error() string {
	return fmt.Sprintf("[GET /leads/observable][%d] getLeadsObservableInternalServerError  %+v", 500, o.Payload)
}

func (o *GetLeadsObservableInternalServerError) String() string {
	return fmt.Sprintf("[GET /leads/observable][%d] getLeadsObservableInternalServerError  %+v", 500, o.Payload)
}

func (o *GetLeadsObservableInternalServerError) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *GetLeadsObservableInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
