// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package leads

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/crm/crm_models"
)

// PostLeadsReader is a Reader for the PostLeads structure.
type PostLeadsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostLeadsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostLeadsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostLeadsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostLeadsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostLeadsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPostLeadsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostLeadsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewPostLeadsOK creates a PostLeadsOK with default headers values
func NewPostLeadsOK() *PostLeadsOK {
	return &PostLeadsOK{}
}

/*
PostLeadsOK describes a response with status code 200, with default header values.

Taxnexus Response with an array of Lead objects
*/
type PostLeadsOK struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *crm_models.LeadResponse
}

// IsSuccess returns true when this post leads o k response has a 2xx status code
func (o *PostLeadsOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this post leads o k response has a 3xx status code
func (o *PostLeadsOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post leads o k response has a 4xx status code
func (o *PostLeadsOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this post leads o k response has a 5xx status code
func (o *PostLeadsOK) IsServerError() bool {
	return false
}

// IsCode returns true when this post leads o k response a status code equal to that given
func (o *PostLeadsOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the post leads o k response
func (o *PostLeadsOK) Code() int {
	return 200
}

func (o *PostLeadsOK) Error() string {
	return fmt.Sprintf("[POST /leads][%d] postLeadsOK  %+v", 200, o.Payload)
}

func (o *PostLeadsOK) String() string {
	return fmt.Sprintf("[POST /leads][%d] postLeadsOK  %+v", 200, o.Payload)
}

func (o *PostLeadsOK) GetPayload() *crm_models.LeadResponse {
	return o.Payload
}

func (o *PostLeadsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(crm_models.LeadResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostLeadsUnauthorized creates a PostLeadsUnauthorized with default headers values
func NewPostLeadsUnauthorized() *PostLeadsUnauthorized {
	return &PostLeadsUnauthorized{}
}

/*
PostLeadsUnauthorized describes a response with status code 401, with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PostLeadsUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

// IsSuccess returns true when this post leads unauthorized response has a 2xx status code
func (o *PostLeadsUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post leads unauthorized response has a 3xx status code
func (o *PostLeadsUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post leads unauthorized response has a 4xx status code
func (o *PostLeadsUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this post leads unauthorized response has a 5xx status code
func (o *PostLeadsUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this post leads unauthorized response a status code equal to that given
func (o *PostLeadsUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the post leads unauthorized response
func (o *PostLeadsUnauthorized) Code() int {
	return 401
}

func (o *PostLeadsUnauthorized) Error() string {
	return fmt.Sprintf("[POST /leads][%d] postLeadsUnauthorized  %+v", 401, o.Payload)
}

func (o *PostLeadsUnauthorized) String() string {
	return fmt.Sprintf("[POST /leads][%d] postLeadsUnauthorized  %+v", 401, o.Payload)
}

func (o *PostLeadsUnauthorized) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *PostLeadsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostLeadsForbidden creates a PostLeadsForbidden with default headers values
func NewPostLeadsForbidden() *PostLeadsForbidden {
	return &PostLeadsForbidden{}
}

/*
PostLeadsForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type PostLeadsForbidden struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

// IsSuccess returns true when this post leads forbidden response has a 2xx status code
func (o *PostLeadsForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post leads forbidden response has a 3xx status code
func (o *PostLeadsForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post leads forbidden response has a 4xx status code
func (o *PostLeadsForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this post leads forbidden response has a 5xx status code
func (o *PostLeadsForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this post leads forbidden response a status code equal to that given
func (o *PostLeadsForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the post leads forbidden response
func (o *PostLeadsForbidden) Code() int {
	return 403
}

func (o *PostLeadsForbidden) Error() string {
	return fmt.Sprintf("[POST /leads][%d] postLeadsForbidden  %+v", 403, o.Payload)
}

func (o *PostLeadsForbidden) String() string {
	return fmt.Sprintf("[POST /leads][%d] postLeadsForbidden  %+v", 403, o.Payload)
}

func (o *PostLeadsForbidden) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *PostLeadsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostLeadsNotFound creates a PostLeadsNotFound with default headers values
func NewPostLeadsNotFound() *PostLeadsNotFound {
	return &PostLeadsNotFound{}
}

/*
PostLeadsNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type PostLeadsNotFound struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

// IsSuccess returns true when this post leads not found response has a 2xx status code
func (o *PostLeadsNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post leads not found response has a 3xx status code
func (o *PostLeadsNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post leads not found response has a 4xx status code
func (o *PostLeadsNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this post leads not found response has a 5xx status code
func (o *PostLeadsNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this post leads not found response a status code equal to that given
func (o *PostLeadsNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the post leads not found response
func (o *PostLeadsNotFound) Code() int {
	return 404
}

func (o *PostLeadsNotFound) Error() string {
	return fmt.Sprintf("[POST /leads][%d] postLeadsNotFound  %+v", 404, o.Payload)
}

func (o *PostLeadsNotFound) String() string {
	return fmt.Sprintf("[POST /leads][%d] postLeadsNotFound  %+v", 404, o.Payload)
}

func (o *PostLeadsNotFound) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *PostLeadsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostLeadsUnprocessableEntity creates a PostLeadsUnprocessableEntity with default headers values
func NewPostLeadsUnprocessableEntity() *PostLeadsUnprocessableEntity {
	return &PostLeadsUnprocessableEntity{}
}

/*
PostLeadsUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PostLeadsUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

// IsSuccess returns true when this post leads unprocessable entity response has a 2xx status code
func (o *PostLeadsUnprocessableEntity) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post leads unprocessable entity response has a 3xx status code
func (o *PostLeadsUnprocessableEntity) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post leads unprocessable entity response has a 4xx status code
func (o *PostLeadsUnprocessableEntity) IsClientError() bool {
	return true
}

// IsServerError returns true when this post leads unprocessable entity response has a 5xx status code
func (o *PostLeadsUnprocessableEntity) IsServerError() bool {
	return false
}

// IsCode returns true when this post leads unprocessable entity response a status code equal to that given
func (o *PostLeadsUnprocessableEntity) IsCode(code int) bool {
	return code == 422
}

// Code gets the status code for the post leads unprocessable entity response
func (o *PostLeadsUnprocessableEntity) Code() int {
	return 422
}

func (o *PostLeadsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[POST /leads][%d] postLeadsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PostLeadsUnprocessableEntity) String() string {
	return fmt.Sprintf("[POST /leads][%d] postLeadsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PostLeadsUnprocessableEntity) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *PostLeadsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostLeadsInternalServerError creates a PostLeadsInternalServerError with default headers values
func NewPostLeadsInternalServerError() *PostLeadsInternalServerError {
	return &PostLeadsInternalServerError{}
}

/*
PostLeadsInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type PostLeadsInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

// IsSuccess returns true when this post leads internal server error response has a 2xx status code
func (o *PostLeadsInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post leads internal server error response has a 3xx status code
func (o *PostLeadsInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post leads internal server error response has a 4xx status code
func (o *PostLeadsInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this post leads internal server error response has a 5xx status code
func (o *PostLeadsInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this post leads internal server error response a status code equal to that given
func (o *PostLeadsInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the post leads internal server error response
func (o *PostLeadsInternalServerError) Code() int {
	return 500
}

func (o *PostLeadsInternalServerError) Error() string {
	return fmt.Sprintf("[POST /leads][%d] postLeadsInternalServerError  %+v", 500, o.Payload)
}

func (o *PostLeadsInternalServerError) String() string {
	return fmt.Sprintf("[POST /leads][%d] postLeadsInternalServerError  %+v", 500, o.Payload)
}

func (o *PostLeadsInternalServerError) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *PostLeadsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
