// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package cluster

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/devops/devops_models"
)

// GetClusterReader is a Reader for the GetCluster structure.
type GetClusterReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetClusterReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetClusterOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetClusterUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetClusterForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetClusterNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetClusterUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetClusterInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetClusterOK creates a GetClusterOK with default headers values
func NewGetClusterOK() *GetClusterOK {
	return &GetClusterOK{}
}

/*
GetClusterOK describes a response with status code 200, with default header values.

Single Cluster record response
*/
type GetClusterOK struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Cluster
}

// IsSuccess returns true when this get cluster o k response has a 2xx status code
func (o *GetClusterOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get cluster o k response has a 3xx status code
func (o *GetClusterOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get cluster o k response has a 4xx status code
func (o *GetClusterOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get cluster o k response has a 5xx status code
func (o *GetClusterOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get cluster o k response a status code equal to that given
func (o *GetClusterOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get cluster o k response
func (o *GetClusterOK) Code() int {
	return 200
}

func (o *GetClusterOK) Error() string {
	return fmt.Sprintf("[GET /clusters/{clusterIdPath}][%d] getClusterOK  %+v", 200, o.Payload)
}

func (o *GetClusterOK) String() string {
	return fmt.Sprintf("[GET /clusters/{clusterIdPath}][%d] getClusterOK  %+v", 200, o.Payload)
}

func (o *GetClusterOK) GetPayload() *devops_models.Cluster {
	return o.Payload
}

func (o *GetClusterOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Cluster)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetClusterUnauthorized creates a GetClusterUnauthorized with default headers values
func NewGetClusterUnauthorized() *GetClusterUnauthorized {
	return &GetClusterUnauthorized{}
}

/*
GetClusterUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type GetClusterUnauthorized struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Error
}

// IsSuccess returns true when this get cluster unauthorized response has a 2xx status code
func (o *GetClusterUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get cluster unauthorized response has a 3xx status code
func (o *GetClusterUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get cluster unauthorized response has a 4xx status code
func (o *GetClusterUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this get cluster unauthorized response has a 5xx status code
func (o *GetClusterUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this get cluster unauthorized response a status code equal to that given
func (o *GetClusterUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the get cluster unauthorized response
func (o *GetClusterUnauthorized) Code() int {
	return 401
}

func (o *GetClusterUnauthorized) Error() string {
	return fmt.Sprintf("[GET /clusters/{clusterIdPath}][%d] getClusterUnauthorized  %+v", 401, o.Payload)
}

func (o *GetClusterUnauthorized) String() string {
	return fmt.Sprintf("[GET /clusters/{clusterIdPath}][%d] getClusterUnauthorized  %+v", 401, o.Payload)
}

func (o *GetClusterUnauthorized) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetClusterUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetClusterForbidden creates a GetClusterForbidden with default headers values
func NewGetClusterForbidden() *GetClusterForbidden {
	return &GetClusterForbidden{}
}

/*
GetClusterForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type GetClusterForbidden struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

// IsSuccess returns true when this get cluster forbidden response has a 2xx status code
func (o *GetClusterForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get cluster forbidden response has a 3xx status code
func (o *GetClusterForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get cluster forbidden response has a 4xx status code
func (o *GetClusterForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this get cluster forbidden response has a 5xx status code
func (o *GetClusterForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this get cluster forbidden response a status code equal to that given
func (o *GetClusterForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the get cluster forbidden response
func (o *GetClusterForbidden) Code() int {
	return 403
}

func (o *GetClusterForbidden) Error() string {
	return fmt.Sprintf("[GET /clusters/{clusterIdPath}][%d] getClusterForbidden  %+v", 403, o.Payload)
}

func (o *GetClusterForbidden) String() string {
	return fmt.Sprintf("[GET /clusters/{clusterIdPath}][%d] getClusterForbidden  %+v", 403, o.Payload)
}

func (o *GetClusterForbidden) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetClusterForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetClusterNotFound creates a GetClusterNotFound with default headers values
func NewGetClusterNotFound() *GetClusterNotFound {
	return &GetClusterNotFound{}
}

/*
GetClusterNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type GetClusterNotFound struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

// IsSuccess returns true when this get cluster not found response has a 2xx status code
func (o *GetClusterNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get cluster not found response has a 3xx status code
func (o *GetClusterNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get cluster not found response has a 4xx status code
func (o *GetClusterNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this get cluster not found response has a 5xx status code
func (o *GetClusterNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this get cluster not found response a status code equal to that given
func (o *GetClusterNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the get cluster not found response
func (o *GetClusterNotFound) Code() int {
	return 404
}

func (o *GetClusterNotFound) Error() string {
	return fmt.Sprintf("[GET /clusters/{clusterIdPath}][%d] getClusterNotFound  %+v", 404, o.Payload)
}

func (o *GetClusterNotFound) String() string {
	return fmt.Sprintf("[GET /clusters/{clusterIdPath}][%d] getClusterNotFound  %+v", 404, o.Payload)
}

func (o *GetClusterNotFound) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetClusterNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetClusterUnprocessableEntity creates a GetClusterUnprocessableEntity with default headers values
func NewGetClusterUnprocessableEntity() *GetClusterUnprocessableEntity {
	return &GetClusterUnprocessableEntity{}
}

/*
GetClusterUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetClusterUnprocessableEntity struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Error
}

// IsSuccess returns true when this get cluster unprocessable entity response has a 2xx status code
func (o *GetClusterUnprocessableEntity) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get cluster unprocessable entity response has a 3xx status code
func (o *GetClusterUnprocessableEntity) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get cluster unprocessable entity response has a 4xx status code
func (o *GetClusterUnprocessableEntity) IsClientError() bool {
	return true
}

// IsServerError returns true when this get cluster unprocessable entity response has a 5xx status code
func (o *GetClusterUnprocessableEntity) IsServerError() bool {
	return false
}

// IsCode returns true when this get cluster unprocessable entity response a status code equal to that given
func (o *GetClusterUnprocessableEntity) IsCode(code int) bool {
	return code == 422
}

// Code gets the status code for the get cluster unprocessable entity response
func (o *GetClusterUnprocessableEntity) Code() int {
	return 422
}

func (o *GetClusterUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /clusters/{clusterIdPath}][%d] getClusterUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetClusterUnprocessableEntity) String() string {
	return fmt.Sprintf("[GET /clusters/{clusterIdPath}][%d] getClusterUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetClusterUnprocessableEntity) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetClusterUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetClusterInternalServerError creates a GetClusterInternalServerError with default headers values
func NewGetClusterInternalServerError() *GetClusterInternalServerError {
	return &GetClusterInternalServerError{}
}

/*
GetClusterInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type GetClusterInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

// IsSuccess returns true when this get cluster internal server error response has a 2xx status code
func (o *GetClusterInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get cluster internal server error response has a 3xx status code
func (o *GetClusterInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get cluster internal server error response has a 4xx status code
func (o *GetClusterInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this get cluster internal server error response has a 5xx status code
func (o *GetClusterInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this get cluster internal server error response a status code equal to that given
func (o *GetClusterInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the get cluster internal server error response
func (o *GetClusterInternalServerError) Code() int {
	return 500
}

func (o *GetClusterInternalServerError) Error() string {
	return fmt.Sprintf("[GET /clusters/{clusterIdPath}][%d] getClusterInternalServerError  %+v", 500, o.Payload)
}

func (o *GetClusterInternalServerError) String() string {
	return fmt.Sprintf("[GET /clusters/{clusterIdPath}][%d] getClusterInternalServerError  %+v", 500, o.Payload)
}

func (o *GetClusterInternalServerError) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetClusterInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
