// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package database

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/devops/devops_models"
)

// GetDatabasesReader is a Reader for the GetDatabases structure.
type GetDatabasesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetDatabasesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetDatabasesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetDatabasesUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetDatabasesForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetDatabasesNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetDatabasesUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetDatabasesInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetDatabasesOK creates a GetDatabasesOK with default headers values
func NewGetDatabasesOK() *GetDatabasesOK {
	return &GetDatabasesOK{}
}

/*
GetDatabasesOK describes a response with status code 200, with default header values.

Taxnexus Response with Database objects
*/
type GetDatabasesOK struct {
	AccessControlAllowOrigin string

	Payload *devops_models.DatabaseResponse
}

// IsSuccess returns true when this get databases o k response has a 2xx status code
func (o *GetDatabasesOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get databases o k response has a 3xx status code
func (o *GetDatabasesOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get databases o k response has a 4xx status code
func (o *GetDatabasesOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get databases o k response has a 5xx status code
func (o *GetDatabasesOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get databases o k response a status code equal to that given
func (o *GetDatabasesOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get databases o k response
func (o *GetDatabasesOK) Code() int {
	return 200
}

func (o *GetDatabasesOK) Error() string {
	return fmt.Sprintf("[GET /databases][%d] getDatabasesOK  %+v", 200, o.Payload)
}

func (o *GetDatabasesOK) String() string {
	return fmt.Sprintf("[GET /databases][%d] getDatabasesOK  %+v", 200, o.Payload)
}

func (o *GetDatabasesOK) GetPayload() *devops_models.DatabaseResponse {
	return o.Payload
}

func (o *GetDatabasesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.DatabaseResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDatabasesUnauthorized creates a GetDatabasesUnauthorized with default headers values
func NewGetDatabasesUnauthorized() *GetDatabasesUnauthorized {
	return &GetDatabasesUnauthorized{}
}

/*
GetDatabasesUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type GetDatabasesUnauthorized struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Error
}

// IsSuccess returns true when this get databases unauthorized response has a 2xx status code
func (o *GetDatabasesUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get databases unauthorized response has a 3xx status code
func (o *GetDatabasesUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get databases unauthorized response has a 4xx status code
func (o *GetDatabasesUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this get databases unauthorized response has a 5xx status code
func (o *GetDatabasesUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this get databases unauthorized response a status code equal to that given
func (o *GetDatabasesUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the get databases unauthorized response
func (o *GetDatabasesUnauthorized) Code() int {
	return 401
}

func (o *GetDatabasesUnauthorized) Error() string {
	return fmt.Sprintf("[GET /databases][%d] getDatabasesUnauthorized  %+v", 401, o.Payload)
}

func (o *GetDatabasesUnauthorized) String() string {
	return fmt.Sprintf("[GET /databases][%d] getDatabasesUnauthorized  %+v", 401, o.Payload)
}

func (o *GetDatabasesUnauthorized) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetDatabasesUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDatabasesForbidden creates a GetDatabasesForbidden with default headers values
func NewGetDatabasesForbidden() *GetDatabasesForbidden {
	return &GetDatabasesForbidden{}
}

/*
GetDatabasesForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type GetDatabasesForbidden struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

// IsSuccess returns true when this get databases forbidden response has a 2xx status code
func (o *GetDatabasesForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get databases forbidden response has a 3xx status code
func (o *GetDatabasesForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get databases forbidden response has a 4xx status code
func (o *GetDatabasesForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this get databases forbidden response has a 5xx status code
func (o *GetDatabasesForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this get databases forbidden response a status code equal to that given
func (o *GetDatabasesForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the get databases forbidden response
func (o *GetDatabasesForbidden) Code() int {
	return 403
}

func (o *GetDatabasesForbidden) Error() string {
	return fmt.Sprintf("[GET /databases][%d] getDatabasesForbidden  %+v", 403, o.Payload)
}

func (o *GetDatabasesForbidden) String() string {
	return fmt.Sprintf("[GET /databases][%d] getDatabasesForbidden  %+v", 403, o.Payload)
}

func (o *GetDatabasesForbidden) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetDatabasesForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDatabasesNotFound creates a GetDatabasesNotFound with default headers values
func NewGetDatabasesNotFound() *GetDatabasesNotFound {
	return &GetDatabasesNotFound{}
}

/*
GetDatabasesNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type GetDatabasesNotFound struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

// IsSuccess returns true when this get databases not found response has a 2xx status code
func (o *GetDatabasesNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get databases not found response has a 3xx status code
func (o *GetDatabasesNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get databases not found response has a 4xx status code
func (o *GetDatabasesNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this get databases not found response has a 5xx status code
func (o *GetDatabasesNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this get databases not found response a status code equal to that given
func (o *GetDatabasesNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the get databases not found response
func (o *GetDatabasesNotFound) Code() int {
	return 404
}

func (o *GetDatabasesNotFound) Error() string {
	return fmt.Sprintf("[GET /databases][%d] getDatabasesNotFound  %+v", 404, o.Payload)
}

func (o *GetDatabasesNotFound) String() string {
	return fmt.Sprintf("[GET /databases][%d] getDatabasesNotFound  %+v", 404, o.Payload)
}

func (o *GetDatabasesNotFound) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetDatabasesNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDatabasesUnprocessableEntity creates a GetDatabasesUnprocessableEntity with default headers values
func NewGetDatabasesUnprocessableEntity() *GetDatabasesUnprocessableEntity {
	return &GetDatabasesUnprocessableEntity{}
}

/*
GetDatabasesUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetDatabasesUnprocessableEntity struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Error
}

// IsSuccess returns true when this get databases unprocessable entity response has a 2xx status code
func (o *GetDatabasesUnprocessableEntity) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get databases unprocessable entity response has a 3xx status code
func (o *GetDatabasesUnprocessableEntity) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get databases unprocessable entity response has a 4xx status code
func (o *GetDatabasesUnprocessableEntity) IsClientError() bool {
	return true
}

// IsServerError returns true when this get databases unprocessable entity response has a 5xx status code
func (o *GetDatabasesUnprocessableEntity) IsServerError() bool {
	return false
}

// IsCode returns true when this get databases unprocessable entity response a status code equal to that given
func (o *GetDatabasesUnprocessableEntity) IsCode(code int) bool {
	return code == 422
}

// Code gets the status code for the get databases unprocessable entity response
func (o *GetDatabasesUnprocessableEntity) Code() int {
	return 422
}

func (o *GetDatabasesUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /databases][%d] getDatabasesUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetDatabasesUnprocessableEntity) String() string {
	return fmt.Sprintf("[GET /databases][%d] getDatabasesUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetDatabasesUnprocessableEntity) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetDatabasesUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDatabasesInternalServerError creates a GetDatabasesInternalServerError with default headers values
func NewGetDatabasesInternalServerError() *GetDatabasesInternalServerError {
	return &GetDatabasesInternalServerError{}
}

/*
GetDatabasesInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type GetDatabasesInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

// IsSuccess returns true when this get databases internal server error response has a 2xx status code
func (o *GetDatabasesInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get databases internal server error response has a 3xx status code
func (o *GetDatabasesInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get databases internal server error response has a 4xx status code
func (o *GetDatabasesInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this get databases internal server error response has a 5xx status code
func (o *GetDatabasesInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this get databases internal server error response a status code equal to that given
func (o *GetDatabasesInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the get databases internal server error response
func (o *GetDatabasesInternalServerError) Code() int {
	return 500
}

func (o *GetDatabasesInternalServerError) Error() string {
	return fmt.Sprintf("[GET /databases][%d] getDatabasesInternalServerError  %+v", 500, o.Payload)
}

func (o *GetDatabasesInternalServerError) String() string {
	return fmt.Sprintf("[GET /databases][%d] getDatabasesInternalServerError  %+v", 500, o.Payload)
}

func (o *GetDatabasesInternalServerError) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetDatabasesInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
