// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package template

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/devops/devops_models"
)

// GetTemplateReader is a Reader for the GetTemplate structure.
type GetTemplateReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetTemplateReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetTemplateOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetTemplateUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetTemplateForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetTemplateNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetTemplateUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetTemplateInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetTemplateOK creates a GetTemplateOK with default headers values
func NewGetTemplateOK() *GetTemplateOK {
	return &GetTemplateOK{}
}

/*
GetTemplateOK describes a response with status code 200, with default header values.

Single Template record response
*/
type GetTemplateOK struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Template
}

// IsSuccess returns true when this get template o k response has a 2xx status code
func (o *GetTemplateOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get template o k response has a 3xx status code
func (o *GetTemplateOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get template o k response has a 4xx status code
func (o *GetTemplateOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get template o k response has a 5xx status code
func (o *GetTemplateOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get template o k response a status code equal to that given
func (o *GetTemplateOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get template o k response
func (o *GetTemplateOK) Code() int {
	return 200
}

func (o *GetTemplateOK) Error() string {
	return fmt.Sprintf("[GET /templates/{templateIdPath}][%d] getTemplateOK  %+v", 200, o.Payload)
}

func (o *GetTemplateOK) String() string {
	return fmt.Sprintf("[GET /templates/{templateIdPath}][%d] getTemplateOK  %+v", 200, o.Payload)
}

func (o *GetTemplateOK) GetPayload() *devops_models.Template {
	return o.Payload
}

func (o *GetTemplateOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Template)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTemplateUnauthorized creates a GetTemplateUnauthorized with default headers values
func NewGetTemplateUnauthorized() *GetTemplateUnauthorized {
	return &GetTemplateUnauthorized{}
}

/*
GetTemplateUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type GetTemplateUnauthorized struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Error
}

// IsSuccess returns true when this get template unauthorized response has a 2xx status code
func (o *GetTemplateUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get template unauthorized response has a 3xx status code
func (o *GetTemplateUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get template unauthorized response has a 4xx status code
func (o *GetTemplateUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this get template unauthorized response has a 5xx status code
func (o *GetTemplateUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this get template unauthorized response a status code equal to that given
func (o *GetTemplateUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the get template unauthorized response
func (o *GetTemplateUnauthorized) Code() int {
	return 401
}

func (o *GetTemplateUnauthorized) Error() string {
	return fmt.Sprintf("[GET /templates/{templateIdPath}][%d] getTemplateUnauthorized  %+v", 401, o.Payload)
}

func (o *GetTemplateUnauthorized) String() string {
	return fmt.Sprintf("[GET /templates/{templateIdPath}][%d] getTemplateUnauthorized  %+v", 401, o.Payload)
}

func (o *GetTemplateUnauthorized) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetTemplateUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTemplateForbidden creates a GetTemplateForbidden with default headers values
func NewGetTemplateForbidden() *GetTemplateForbidden {
	return &GetTemplateForbidden{}
}

/*
GetTemplateForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type GetTemplateForbidden struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

// IsSuccess returns true when this get template forbidden response has a 2xx status code
func (o *GetTemplateForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get template forbidden response has a 3xx status code
func (o *GetTemplateForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get template forbidden response has a 4xx status code
func (o *GetTemplateForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this get template forbidden response has a 5xx status code
func (o *GetTemplateForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this get template forbidden response a status code equal to that given
func (o *GetTemplateForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the get template forbidden response
func (o *GetTemplateForbidden) Code() int {
	return 403
}

func (o *GetTemplateForbidden) Error() string {
	return fmt.Sprintf("[GET /templates/{templateIdPath}][%d] getTemplateForbidden  %+v", 403, o.Payload)
}

func (o *GetTemplateForbidden) String() string {
	return fmt.Sprintf("[GET /templates/{templateIdPath}][%d] getTemplateForbidden  %+v", 403, o.Payload)
}

func (o *GetTemplateForbidden) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetTemplateForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTemplateNotFound creates a GetTemplateNotFound with default headers values
func NewGetTemplateNotFound() *GetTemplateNotFound {
	return &GetTemplateNotFound{}
}

/*
GetTemplateNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type GetTemplateNotFound struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

// IsSuccess returns true when this get template not found response has a 2xx status code
func (o *GetTemplateNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get template not found response has a 3xx status code
func (o *GetTemplateNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get template not found response has a 4xx status code
func (o *GetTemplateNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this get template not found response has a 5xx status code
func (o *GetTemplateNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this get template not found response a status code equal to that given
func (o *GetTemplateNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the get template not found response
func (o *GetTemplateNotFound) Code() int {
	return 404
}

func (o *GetTemplateNotFound) Error() string {
	return fmt.Sprintf("[GET /templates/{templateIdPath}][%d] getTemplateNotFound  %+v", 404, o.Payload)
}

func (o *GetTemplateNotFound) String() string {
	return fmt.Sprintf("[GET /templates/{templateIdPath}][%d] getTemplateNotFound  %+v", 404, o.Payload)
}

func (o *GetTemplateNotFound) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetTemplateNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTemplateUnprocessableEntity creates a GetTemplateUnprocessableEntity with default headers values
func NewGetTemplateUnprocessableEntity() *GetTemplateUnprocessableEntity {
	return &GetTemplateUnprocessableEntity{}
}

/*
GetTemplateUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetTemplateUnprocessableEntity struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *devops_models.Error
}

// IsSuccess returns true when this get template unprocessable entity response has a 2xx status code
func (o *GetTemplateUnprocessableEntity) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get template unprocessable entity response has a 3xx status code
func (o *GetTemplateUnprocessableEntity) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get template unprocessable entity response has a 4xx status code
func (o *GetTemplateUnprocessableEntity) IsClientError() bool {
	return true
}

// IsServerError returns true when this get template unprocessable entity response has a 5xx status code
func (o *GetTemplateUnprocessableEntity) IsServerError() bool {
	return false
}

// IsCode returns true when this get template unprocessable entity response a status code equal to that given
func (o *GetTemplateUnprocessableEntity) IsCode(code int) bool {
	return code == 422
}

// Code gets the status code for the get template unprocessable entity response
func (o *GetTemplateUnprocessableEntity) Code() int {
	return 422
}

func (o *GetTemplateUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /templates/{templateIdPath}][%d] getTemplateUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetTemplateUnprocessableEntity) String() string {
	return fmt.Sprintf("[GET /templates/{templateIdPath}][%d] getTemplateUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetTemplateUnprocessableEntity) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetTemplateUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTemplateInternalServerError creates a GetTemplateInternalServerError with default headers values
func NewGetTemplateInternalServerError() *GetTemplateInternalServerError {
	return &GetTemplateInternalServerError{}
}

/*
GetTemplateInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type GetTemplateInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

// IsSuccess returns true when this get template internal server error response has a 2xx status code
func (o *GetTemplateInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get template internal server error response has a 3xx status code
func (o *GetTemplateInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get template internal server error response has a 4xx status code
func (o *GetTemplateInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this get template internal server error response has a 5xx status code
func (o *GetTemplateInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this get template internal server error response a status code equal to that given
func (o *GetTemplateInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the get template internal server error response
func (o *GetTemplateInternalServerError) Code() int {
	return 500
}

func (o *GetTemplateInternalServerError) Error() string {
	return fmt.Sprintf("[GET /templates/{templateIdPath}][%d] getTemplateInternalServerError  %+v", 500, o.Payload)
}

func (o *GetTemplateInternalServerError) String() string {
	return fmt.Sprintf("[GET /templates/{templateIdPath}][%d] getTemplateInternalServerError  %+v", 500, o.Payload)
}

func (o *GetTemplateInternalServerError) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *GetTemplateInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
