// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package accounts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/sfgate/sfgate_models"
)

// PutAccountReader is a Reader for the PutAccount structure.
type PutAccountReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PutAccountReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPutAccountOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPutAccountUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPutAccountForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPutAccountNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPutAccountUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPutAccountInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewPutAccountOK creates a PutAccountOK with default headers values
func NewPutAccountOK() *PutAccountOK {
	return &PutAccountOK{}
}

/*
PutAccountOK describes a response with status code 200, with default header values.

Taxnexus Response with Account objects with Contacts
*/
type PutAccountOK struct {
	AccessControlAllowOrigin string
	CacheControl             string

	Payload *sfgate_models.AccountResponse
}

// IsSuccess returns true when this put account o k response has a 2xx status code
func (o *PutAccountOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this put account o k response has a 3xx status code
func (o *PutAccountOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this put account o k response has a 4xx status code
func (o *PutAccountOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this put account o k response has a 5xx status code
func (o *PutAccountOK) IsServerError() bool {
	return false
}

// IsCode returns true when this put account o k response a status code equal to that given
func (o *PutAccountOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the put account o k response
func (o *PutAccountOK) Code() int {
	return 200
}

func (o *PutAccountOK) Error() string {
	return fmt.Sprintf("[PUT /accounts][%d] putAccountOK  %+v", 200, o.Payload)
}

func (o *PutAccountOK) String() string {
	return fmt.Sprintf("[PUT /accounts][%d] putAccountOK  %+v", 200, o.Payload)
}

func (o *PutAccountOK) GetPayload() *sfgate_models.AccountResponse {
	return o.Payload
}

func (o *PutAccountOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	// hydrates response header Cache-Control
	hdrCacheControl := response.GetHeader("Cache-Control")

	if hdrCacheControl != "" {
		o.CacheControl = hdrCacheControl
	}

	o.Payload = new(sfgate_models.AccountResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutAccountUnauthorized creates a PutAccountUnauthorized with default headers values
func NewPutAccountUnauthorized() *PutAccountUnauthorized {
	return &PutAccountUnauthorized{}
}

/*
PutAccountUnauthorized describes a response with status code 401, with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PutAccountUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *sfgate_models.Error
}

// IsSuccess returns true when this put account unauthorized response has a 2xx status code
func (o *PutAccountUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this put account unauthorized response has a 3xx status code
func (o *PutAccountUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this put account unauthorized response has a 4xx status code
func (o *PutAccountUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this put account unauthorized response has a 5xx status code
func (o *PutAccountUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this put account unauthorized response a status code equal to that given
func (o *PutAccountUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the put account unauthorized response
func (o *PutAccountUnauthorized) Code() int {
	return 401
}

func (o *PutAccountUnauthorized) Error() string {
	return fmt.Sprintf("[PUT /accounts][%d] putAccountUnauthorized  %+v", 401, o.Payload)
}

func (o *PutAccountUnauthorized) String() string {
	return fmt.Sprintf("[PUT /accounts][%d] putAccountUnauthorized  %+v", 401, o.Payload)
}

func (o *PutAccountUnauthorized) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *PutAccountUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutAccountForbidden creates a PutAccountForbidden with default headers values
func NewPutAccountForbidden() *PutAccountForbidden {
	return &PutAccountForbidden{}
}

/*
PutAccountForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type PutAccountForbidden struct {
	AccessControlAllowOrigin string

	Payload *sfgate_models.Error
}

// IsSuccess returns true when this put account forbidden response has a 2xx status code
func (o *PutAccountForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this put account forbidden response has a 3xx status code
func (o *PutAccountForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this put account forbidden response has a 4xx status code
func (o *PutAccountForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this put account forbidden response has a 5xx status code
func (o *PutAccountForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this put account forbidden response a status code equal to that given
func (o *PutAccountForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the put account forbidden response
func (o *PutAccountForbidden) Code() int {
	return 403
}

func (o *PutAccountForbidden) Error() string {
	return fmt.Sprintf("[PUT /accounts][%d] putAccountForbidden  %+v", 403, o.Payload)
}

func (o *PutAccountForbidden) String() string {
	return fmt.Sprintf("[PUT /accounts][%d] putAccountForbidden  %+v", 403, o.Payload)
}

func (o *PutAccountForbidden) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *PutAccountForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutAccountNotFound creates a PutAccountNotFound with default headers values
func NewPutAccountNotFound() *PutAccountNotFound {
	return &PutAccountNotFound{}
}

/*
PutAccountNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type PutAccountNotFound struct {
	AccessControlAllowOrigin string

	Payload *sfgate_models.Error
}

// IsSuccess returns true when this put account not found response has a 2xx status code
func (o *PutAccountNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this put account not found response has a 3xx status code
func (o *PutAccountNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this put account not found response has a 4xx status code
func (o *PutAccountNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this put account not found response has a 5xx status code
func (o *PutAccountNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this put account not found response a status code equal to that given
func (o *PutAccountNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the put account not found response
func (o *PutAccountNotFound) Code() int {
	return 404
}

func (o *PutAccountNotFound) Error() string {
	return fmt.Sprintf("[PUT /accounts][%d] putAccountNotFound  %+v", 404, o.Payload)
}

func (o *PutAccountNotFound) String() string {
	return fmt.Sprintf("[PUT /accounts][%d] putAccountNotFound  %+v", 404, o.Payload)
}

func (o *PutAccountNotFound) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *PutAccountNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutAccountUnprocessableEntity creates a PutAccountUnprocessableEntity with default headers values
func NewPutAccountUnprocessableEntity() *PutAccountUnprocessableEntity {
	return &PutAccountUnprocessableEntity{}
}

/*
PutAccountUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PutAccountUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *sfgate_models.Error
}

// IsSuccess returns true when this put account unprocessable entity response has a 2xx status code
func (o *PutAccountUnprocessableEntity) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this put account unprocessable entity response has a 3xx status code
func (o *PutAccountUnprocessableEntity) IsRedirect() bool {
	return false
}

// IsClientError returns true when this put account unprocessable entity response has a 4xx status code
func (o *PutAccountUnprocessableEntity) IsClientError() bool {
	return true
}

// IsServerError returns true when this put account unprocessable entity response has a 5xx status code
func (o *PutAccountUnprocessableEntity) IsServerError() bool {
	return false
}

// IsCode returns true when this put account unprocessable entity response a status code equal to that given
func (o *PutAccountUnprocessableEntity) IsCode(code int) bool {
	return code == 422
}

// Code gets the status code for the put account unprocessable entity response
func (o *PutAccountUnprocessableEntity) Code() int {
	return 422
}

func (o *PutAccountUnprocessableEntity) Error() string {
	return fmt.Sprintf("[PUT /accounts][%d] putAccountUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PutAccountUnprocessableEntity) String() string {
	return fmt.Sprintf("[PUT /accounts][%d] putAccountUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PutAccountUnprocessableEntity) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *PutAccountUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutAccountInternalServerError creates a PutAccountInternalServerError with default headers values
func NewPutAccountInternalServerError() *PutAccountInternalServerError {
	return &PutAccountInternalServerError{}
}

/*
PutAccountInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type PutAccountInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *sfgate_models.Error
}

// IsSuccess returns true when this put account internal server error response has a 2xx status code
func (o *PutAccountInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this put account internal server error response has a 3xx status code
func (o *PutAccountInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this put account internal server error response has a 4xx status code
func (o *PutAccountInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this put account internal server error response has a 5xx status code
func (o *PutAccountInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this put account internal server error response a status code equal to that given
func (o *PutAccountInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the put account internal server error response
func (o *PutAccountInternalServerError) Code() int {
	return 500
}

func (o *PutAccountInternalServerError) Error() string {
	return fmt.Sprintf("[PUT /accounts][%d] putAccountInternalServerError  %+v", 500, o.Payload)
}

func (o *PutAccountInternalServerError) String() string {
	return fmt.Sprintf("[PUT /accounts][%d] putAccountInternalServerError  %+v", 500, o.Payload)
}

func (o *PutAccountInternalServerError) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *PutAccountInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
