// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package industryproducts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetIndustryProductsParams creates a new GetIndustryProductsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetIndustryProductsParams() *GetIndustryProductsParams {
	return &GetIndustryProductsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetIndustryProductsParamsWithTimeout creates a new GetIndustryProductsParams object
// with the ability to set a timeout on a request.
func NewGetIndustryProductsParamsWithTimeout(timeout time.Duration) *GetIndustryProductsParams {
	return &GetIndustryProductsParams{
		timeout: timeout,
	}
}

// NewGetIndustryProductsParamsWithContext creates a new GetIndustryProductsParams object
// with the ability to set a context for a request.
func NewGetIndustryProductsParamsWithContext(ctx context.Context) *GetIndustryProductsParams {
	return &GetIndustryProductsParams{
		Context: ctx,
	}
}

// NewGetIndustryProductsParamsWithHTTPClient creates a new GetIndustryProductsParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetIndustryProductsParamsWithHTTPClient(client *http.Client) *GetIndustryProductsParams {
	return &GetIndustryProductsParams{
		HTTPClient: client,
	}
}

/*
GetIndustryProductsParams contains all the parameters to send to the API endpoint

	for the get industry products operation.

	Typically these are written to a http.Request.
*/
type GetIndustryProductsParams struct {

	/* Active.

	   Only retrieve active records?
	*/
	Active *bool

	/* IndustryProductID.

	   Taxnexus IndustryProduct record ID
	*/
	IndustryProductID *string

	/* Limit.

	   How many objects to return at one time

	   Format: int64
	*/
	Limit *int64

	/* Offset.

	   How many objects to skip?

	   Format: int64
	*/
	Offset *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get industry products params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetIndustryProductsParams) WithDefaults() *GetIndustryProductsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get industry products params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetIndustryProductsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get industry products params
func (o *GetIndustryProductsParams) WithTimeout(timeout time.Duration) *GetIndustryProductsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get industry products params
func (o *GetIndustryProductsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get industry products params
func (o *GetIndustryProductsParams) WithContext(ctx context.Context) *GetIndustryProductsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get industry products params
func (o *GetIndustryProductsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get industry products params
func (o *GetIndustryProductsParams) WithHTTPClient(client *http.Client) *GetIndustryProductsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get industry products params
func (o *GetIndustryProductsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithActive adds the active to the get industry products params
func (o *GetIndustryProductsParams) WithActive(active *bool) *GetIndustryProductsParams {
	o.SetActive(active)
	return o
}

// SetActive adds the active to the get industry products params
func (o *GetIndustryProductsParams) SetActive(active *bool) {
	o.Active = active
}

// WithIndustryProductID adds the industryProductID to the get industry products params
func (o *GetIndustryProductsParams) WithIndustryProductID(industryProductID *string) *GetIndustryProductsParams {
	o.SetIndustryProductID(industryProductID)
	return o
}

// SetIndustryProductID adds the industryProductId to the get industry products params
func (o *GetIndustryProductsParams) SetIndustryProductID(industryProductID *string) {
	o.IndustryProductID = industryProductID
}

// WithLimit adds the limit to the get industry products params
func (o *GetIndustryProductsParams) WithLimit(limit *int64) *GetIndustryProductsParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get industry products params
func (o *GetIndustryProductsParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get industry products params
func (o *GetIndustryProductsParams) WithOffset(offset *int64) *GetIndustryProductsParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get industry products params
func (o *GetIndustryProductsParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WriteToRequest writes these params to a swagger request
func (o *GetIndustryProductsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Active != nil {

		// query param active
		var qrActive bool

		if o.Active != nil {
			qrActive = *o.Active
		}
		qActive := swag.FormatBool(qrActive)
		if qActive != "" {

			if err := r.SetQueryParam("active", qActive); err != nil {
				return err
			}
		}
	}

	if o.IndustryProductID != nil {

		// query param industryProductId
		var qrIndustryProductID string

		if o.IndustryProductID != nil {
			qrIndustryProductID = *o.IndustryProductID
		}
		qIndustryProductID := qrIndustryProductID
		if qIndustryProductID != "" {

			if err := r.SetQueryParam("industryProductId", qIndustryProductID); err != nil {
				return err
			}
		}
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
